#!/bin/bash

#ENV
REP="ppa:graphics-drivers/ppa"
NVVER=""
LOGFILE="install_nvidia_driver.log"


pass_check() {
sudo -k; read -s -p "Please enter the password for sudo: " PW
if sudo -lS &>/dev/null << EOF
$PW
EOF
then
  echo ""
  echo -e "\033[32mPassword correct\033[0m"
else
  echo -e "\033[31mPassword incorrect\033[0m"
  pass_check
fi
}
pass_check

SP="echo $PW"
SS="sudo -S"


# Check secure boot
echo ''
echo '### Step 1 Check secure boot ###'

if $SP | $SS mokutil --sb-state | grep -q "enabled"; then
  echo ''
  echo -e "\033[31m ERROR SecureBoot enabled\033[0m\n Exit!"
  exit 1
else
  echo ''
  echo -e "\033[32m SecureBoot disabled \033[0m\n"
fi


# Start
echo  -e "\033[33m### Step 2 - Remove old driver ###\033[0m"
$SP | $SS apt remove -y --purge nvidia-*

echo  -e "\033[33m### Step 3 - Add repository ###\033[0m"
$SP | $SS add-apt-repository -y $REP

echo  -e "\033[33m### Step 4 - Apt update ###\033[0m"
$SP | $SS apt update -y

echo  -e "\033[33m### Step 5 - Install ubuntu-drivers-common ###\033[0m"
$SP | $SS apt install ubuntu-drivers-common

echo  -e "\033[33m### Step 6 - Install nvidia driver 535 ###\033[0m"
$SP | $SS apt install -y nvidia-common --no-install-recommends
$SP | $SS apt install -y nvidia-driver-535 --no-install-recommends

if [ $? -ne 0 ]; then
  echo "Driver is not installed"
  exit 1
fi

echo  -e "\033[33m### Step 7 - Reboot server ###\033[0m"
sleep 10
$SP | $SS reboot now
